/****************************************************************************
 ****************************************************************************
 *
 * export.c
 *
 ****************************************************************************
 ****************************************************************************/





#include <stdio.h>

#include "export.h"
#include "error.h"
#include "debug.h"
#include "verbose.h"
#include "global.h"
#include "options.h"




/****************************************************************************
 *
 * global functions
 *
 ****************************************************************************/




/****************************************************************************
 * export_u16_be
 ****************************************************************************/
cw_u8_t *
export_u16_be(
	cw_u8_t				*data,
	cw_u16_t			val)

	{
	data[0] = (val >> 8) & 0xff;
	data[1] = val & 0xff;
	return (data);
	}



/****************************************************************************
 * export_u16_le
 ****************************************************************************/
cw_u8_t *
export_u16_le(
	cw_u8_t				*data,
	cw_u16_t			val)

	{
	data[0] = val & 0xff;
	data[1] = (val >> 8) & 0xff;
	return (data);
	}



/****************************************************************************
 * export_u32_le
 ****************************************************************************/
cw_u8_t *
export_u32_le(
	cw_u8_t				*data,
	cw_u32_t			val)

	{
	data[0] = val & 0xff;
	data[1] = (val >> 8) & 0xff;
	data[2] = (val >> 16) & 0xff;
	data[3] = (val >> 24) & 0xff;
	return (data);
	}
/******************************************************** Karsten Scheibler */
